#!/bin/sh

# startserver.sh by [BiM]gtk, for running a seals server in Linux 

# the path Quake III Arena is installed in
QUAKE3PATH="/home/quake3/quake3"

# path to seals (default should be fine) 
SEALSPATH="$QUAKE3PATH/seals"

# the name of the server configuration file, _HAS_ to be in $SEALSPATH 
SERVERCONFIG="server.cfg"

# IP address to bind the server too if it has multiple ips ("" for bind to all) 
NET_IP=""

# UDP port number to run the server on
NET_PORT="27960"

# the path of the pidfile, must be writable (default should be fine)
PIDFILEPATH="$SEALSPATH"


# End of configuration, usually you wont need to edit anything below here.

# Running multiple servers on the same box note.
# -----------------------------------------------
# If you want to run multiple seals servers on the same box you want to add:
# +set fs_homepath /home/quake3/.wherever \
# For each different server you want to run on the same machine.
# (The "\" after the line is important, otherwise the line below wont be read!)
# We wont allow seperate servers pb/game/log files to become a mixed up mess. 
# You should also make a copy of this script under a new name as well as make
# another .cfg file for the server and set the SERVERCONFIG in the copy to 
# point to the new .cfg 

PIDFILENAME="$(basename $SERVERCONFIG)"
PIDFILE="$PIDFILEPATH/seals$(echo $PIDFILENAME | cut -f1 -d".").pid"

if [ -z "$2" ]; then
    MAP="ns_sleepingwolf"
else
    MAP="$2"
fi

case $1 in
start)
    $QUAKE3PATH/q3ded \
    +set cvar_restart \
    +set fs_basepath $QUAKE3PATH \
    +set fs_game seals \
    +set vm_game 2 \
    +set sv_pure 1 \
    +set g_gametype 3 \
    +set dedicated 2 \
    +set ttycon 0 \
    +set net_ip $NET_IP \
    +set net_port $NET_PORT \
    +exec $SERVERCONFIG \
    +map $MAP &>/dev/null &
    
    SEALSPID=$!

    echo "seals started with map $MAP and pid $SEALSPID"
    echo "using pidfile: \"$PIDFILE\""
    echo $SEALSPID >$PIDFILE ;;
stop)
    if [ -r $PIDFILE ]; then
        echo "stopping seals"
        kill $(cat $PIDFILE)
        rm -f $PIDFILE 
    else
        echo "missing pidfile: \"$PIDFILE\""
        echo "no seals running or lost pidfile"
    fi
    ;;
*)
    echo "usage $0: {start|stop} [map]" ;;
esac
